% This is the solution for tan(gamma), as only function of
% dz/dm and dz/dh, not alpha; therefore, it's the more general
% solution. There are two solutions.
% SEP-120.
clear all

clear z_der_gen
clear z_sect_gen 
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der 
clear mx_sect_der
clear hx_sect_der

closereq

%%addpath /net/koko/homes/sep/daniel/Research/current/Matlab/pswei

cwv=1;

fprintf('Beginning: backscatter-ps =%d\n',cwv);

g=[0.5:0.1:3.0];

sg=(g-1)./(g+1);

mx_cut=0.;
hx_cut=0;

flag=-1;
show_surf=0;
show_ang=0;

bbgreen=[0,1,0];
bbred=[1,0,0];
bbblue=[0,0,1];
bbcyan=[0,1,1];
bbmagenta=[1,0,1];
bbyellow=[1,1,0];

hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end

for ig=1:length(g)

fprintf('Doing: PS ratio=%d\n',g(ig));

vp_mod=1;
vs_mod=vp_mod/g(ig);

sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);

% Compute surface and its borders
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

fprintf('Cut analytical tangent plane hx=%f \n',hx_cut)
[mx_sect_der,hx_sect_der,dz_dm_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dm,'hx',hx_cut);
fprintf('Cut analytical tangent plane dz_dh at hx=%f \n',hx_cut)
[mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'mx',mx_cut);

A=sg(ig)*(dz_dm_sect_der)-((sg(ig))^2)*dz_dh_sect_der;
B=1-(sg(ig))^2;
C=sg(ig)*(dz_dm_sect_der)-dz_dh_sect_der;

tgt1(ig,:)=(-B+sqrt(B^2-4*A.*C))./(2*A);
tgt2(ig,:)=(-B-sqrt(B^2-4*A.*C))./(2*A);

end

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(dz_dh,mx_ang_gen,hx_ang_gen,flag);

% For PP case:

gone=1;
sgone=0;
vp_mod=1;
vs_mod=vp_mod/gone;
sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);
[z_ang_gen_one,mx_ang_gen_one,hx_ang_gen_one]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[dz_dh_one,dz_dm_one]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

[mx_sect_der_one,hx_sect_der_one,dz_dh_sect_der_one]=cut_section(mx_ang_gen_one,hx_ang_gen_one,dz_dh_one,'mx',mx_cut);

figure
subplot(1,2,1)
h1=mesh(hx_sect_der,g,tgt1);
axis_imp_ang=[min_hx_ang,max_hx_ang,0.5,3.0,-6,6];
axis(axis_imp_ang);

mxa_sect_gen(1:159)=1;
hold on
hplot=plot3(hx_sect_der,mxa_sect_gen,dz_dh_sect_der_one);
set (hplot,'LineWidth',3);

view(60,25)

xlabel('Hx');
ylabel('Phi');
zlabel('dz/dh');

subplot(1,2,2)
h2=mesh(hx_sect_der,g,tgt2);
axis_imp_ang=[min_hx_ang,max_hx_ang,0.5,3.0,-5000,15000];
axis(axis_imp_ang);

view(60,25)

xlabel('Hx');
ylabel('Phi');
zlabel('dz/dh');

