% Comparing the tan(gamma) as function of P-2-S vel. ratio and alpha.
% Note that gamma and alpha are related to P-incidence angle,
% S-reflection angle and structural dip.
clear all

clear z_der_gen
clear z_sect_gen 
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der 
clear mx_sect_der
clear hx_sect_der

closereq

%%%addpath /net/koko/homes/sep/daniel/Research/current/Matlab/pswei

g=[1.1:0.1:3.0]

cwv=1;

fprintf('Beginning: backscatter-ps =%d\n',cwv);

mx_cut=0.;
hx_cut=0;

flag=-1;
show_surf=0;
show_ang=0;

bbgreen=[0,1,0];
bbred=[1,0,0];
bbblue=[0,0,1];
bbcyan=[0,1,1];
bbmagenta=[1,0,1];
bbyellow=[1,1,0];
bbblack=[1,1,1];

hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end

ALPHA=alpha(1,:);

for ig=1:length(g)

fprintf('Doing: PS ratio=',g(ig));

vp_mod=1;
vs_mod=vp_mod/g(ig);

sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);

% Compute surface and its borders
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

fprintf('Cut analytical tangent plane at hx=%f \n',hx_cut)
[mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'mx',mx_cut);

sg=(g(ig)-1)/(g(ig)+1);

num=dz_dh_sect_der-sg*tand(ALPHA);

den=1+sg*dz_dh_sect_der.*tand(ALPHA);

tgt(ig,:)=num./den;

end

h1=mesh(ALPHA,g,atand(tgt));
min_x_alpha=-80;
max_x_alpha=80;
min_y_g=1;
max_y_g=3;
min_z_alpha=-80;
max_z_alpha=80;

axis_imp_ang=[min_x_alpha,max_x_alpha,min_y_g,max_y_g,min_z_alpha,max_z_alpha];
axis(axis_imp_ang);

xlabel('Alpha');
ylabel('Phi');
zlabel('Full-aperture angle');

