
clear all

clear z_der_gen
clear z_sect_gen
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der
clear mx_sect_der
clear hx_sect_der

closereq
closereq
closereq
closereq
%closereq

addpath /net/koko/homes/sep/daniel/Research/current/Matlab/pswei

jump1=1
jump2=1
jump3=0

v_mod=1;

a_v=1;
%a_v_inp=input('Vertical velocity mult?');
%if(a_v_inp ~= ' ')
%  a_v=a_v_inp;
%end

a_h=1.;
%a_h_inp=input('Horizontal velocity mult?');
%if(a_h_inp ~= ' ')
%  a_h=a_h_inp;
%end

s_par_gen(1)=1/(a_v*v_mod);
s_par_gen(2)=1/(a_h*v_mod);

aniso=1;
%aniso_inp=input('Compute analytical derivatives iuncluding anisotropic term (1 or 0)');
%if(aniso_inp ~= ' ')
%%fprintf('Check int in if stat : aniso_inp =%d \n',aniso_inp);
%  aniso=aniso_inp;
%end

fprintf('Beginning: a_v =%f\n',a_v);
fprintf('Beginning: a_h =%f\n',a_h);
fprintf('Beginning: aniso =%d\n',aniso);

%dbquit

%mx_cut=0.5;
mx_cut=0.;
%hx_cut=-0.25;
hx_cut=0;

%flag=-10000000;
flag=-1;

show_surf=0;
show_ang=1;

comp_numer=1;
comp_nomin_phase=1;
comp_nomin=1;

mygreen=[0,1,0];
myred=[1,0,0];
myblue=[0,0,1];
mycyan=[0,1,1];
mymagenta=[1,0,1];
myyellow=[1,1,0];


hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

%n_gamma=179;
%gamma_0=-89;
%d_gamma=1;

%n_gamma=139;
%gamma_0=-69;
%d_gamma=1;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

%n_alpha=179;
%alpha_0=-89;
%d_alpha=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;



for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end


% Compute surface and its extrema
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang(@s_iso,s_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang(@s_iso,@s_iso_der,s_par_gen,t_data,mx_data,hx_data,gamma,alpha,aniso,flag);

if(comp_nomin)
  disp('Compare nominal with analytical surf')
  
  [dz_dh_nomin,dz_dm_nomin]=nomin_tan_plane_ang(gamma,alpha,flag);
  
%  [max_dif,dif_surf]=gen_dif_surf(dz_dh_nomin,dz_dh,'dz/dh gen',flag);
%  [max_dif,dif_surf]=gen_dif_surf(dz_dm_nomin,dz_dm,'dz/dm gen',flag);
end

fprintf('Cut analytical tangent plane with phase angles at hx=%f \n',hx_cut)
[mx_sect_der,hx_sect_der,dz_dm_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dm,'hx',hx_cut);
fprintf('Cut analytical tangent plane with phase angles at hx=%f \n',hx_cut)
[mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'hx',hx_cut);

if(comp_numer)
  disp('Compute numerical dz/dm')
  [mx_sect_gen,hx_sect_gen,z_sect_gen,dz_dm_der_num]=cut_section_der(mx_ang_gen,hx_ang_gen,z_ang_gen,'hx',hx_cut);

%  disp('Compare numerical with analytical surf')
%  [max_dif,dif_surf]=gen_dif_surf(dz_dm_der_num(3:n_alpha-2),dz_dm_sect_der(3:n_alpha-2),'dz/dm analytical and numerical',flag);

end

if(comp_nomin_phase)
  disp('Compute angle mapping')
  [alpha_phase,gamma_phase]=all_phase_group_ang(@s_iso,@s_iso_der,s_par_gen,-1,alpha,gamma);

  disp('Compute nominal tangent plane with phase angles')
  [dz_dh_nomin_phase,dz_dm_nomin_phase]=nomin_tan_plane_ang(gamma_phase,alpha_phase,flag);

fprintf('Cut dz/dm of nominal tangent plane with phase angles at hx=%f \n',hx_cut)
  [mx_sect_der,hx_sect_der,dz_dm_nomin_phase_sect]=cut_section(mx_ang_gen,hx_ang_gen,dz_dm_nomin_phase,'hx',hx_cut);

fprintf('Compare dz/dm nominal phase with analytical surf at hx=%f \n',hx_cut)
  [max_dif,dif_surf]=gen_dif_surf(dz_dm_nomin_phase_sect(3:n_alpha-2),dz_dm_sect_der(3:n_alpha-2),'dz/dm analytical and nominal with phase angles',flag);


fprintf('Cut  dz/dh of nominal tangent plane with phase angles at hx=%f \n',hx_cut)
  [mx_sect_der,hx_sect_der,dz_dh_nomin_phase_sect]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh_nomin_phase,'hx',hx_cut);

fprintf('Compare dz/dh nominal phase with analytical surf at hx=%f \n',hx_cut)
  [max_dif,dif_surf]=gen_dif_surf(dz_dh_nomin_phase_sect(3:n_alpha-2),dz_dh_sect_der(3:n_alpha-2),'dz/dh analytical and nominal with phase angles',flag);

end

az=0;
el=0;

if(show_ang) 
  fprintf('Im showing angle')
  [min_z_sect,max_z_sect,min_mx_sect,max_mx_sect,min_hx_sect,max_hx_sect]=max_min_zmx(atand(dz_dm_sect_der),mx_sect_der,hx_sect_der,flag);
else
  [min_z_sect,max_z_sect,min_mx_sect,max_mx_sect,min_hx_sect,max_hx_sect]=max_min_zmx(dz_dm_sect_der,mx_sect_der,hx_sect_der,flag);
end

axis_der_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_z_sect,1.3*max_z_sect];

if(jump1 ~= 1) 
if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dm_sect_der),'Mx (km)','Hx (km)','Alpha (deg)/dm','Analytical dip',axis_der_ang,myblue,0,0,az,el);
else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dm_sect_der,'Mx (km)','Hx (km)','dz/dm','Analytical dz/dm',axis_der_ang,myblue,0,0,az,el);
end

if(comp_nomin)
  [mx_sect_der,hx_sect_der,dz_dm_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dm_nomin,'hx',hx_cut);
  if(show_ang) 
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dm_sect_der),'Mx (km)','Hx (km)','Alpha (deg)','Nominal dip',axis_der_ang,mygreen,1,0,az,el);
  else
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dm_sect_der,'Mx (km)','Hx (km)','dz/dm','Nominal dz/dm',axis_der_ang,mygreen,1,0,az,el);
  end
end

if(comp_nomin_phase)
  if(show_ang) 
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dm_nomin_phase_sect),'Mx (km)','Hx (km)','Alpha (deg)','Nominal phase dip',axis_der_ang,myred,1,0,az,el);
  else
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dm_nomin_phase_sect,'Mx (km)','Hx (km)','dz/dm','Nominal phase dz/dm',axis_der_ang,myred,1,0,az,el);
  end
end

if(comp_numer)
  if(show_ang) 
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dm_der_num),'Mx (km)','Hx (km)','Alpha (deg)','Numerical dip',axis_der_ang,mycyan,1,0,az,el);
  else
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dm_der_num,'Mx (km)','Hx (km)','dz/dm','Numerical dz/dm',axis_der_ang,mycyan,1,0,az,el);
  end
end

end

if(jump2 ~= 1) 

if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dh_sect_der),'Mx (km)','Hx (km)','Gamma (deg)/dm','Analytical apert constant hx',axis_der_ang,myblue,0,0,az,el);
else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dh_sect_der,'Mx (km)','Hx (km)','dz/dm','Analytical dz/dh at constant hx',axis_der_ang,myblue,0,0,az,el);
end

if(comp_nomin_phase)
  if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dh_nomin_phase_sect),'Mx (km)','Hx (km)','Gamma (deg)','Nominal phase aperture at constant hx',axis_der_ang,myred,1,0,az,el);
  else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dh_nomin_phase_sect,'Mx (km)','Hx (km)','dz/dm','Nominal phase dz/dh at constant hx',axis_der_ang,myred,1,0,az,el);
  end
end

if(comp_nomin)
  [mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh_nomin,'hx',hx_cut);
  if(show_ang) 
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dh_sect_der),'Mx (km)','Hx (km)','Gamma (deg)','reflection aperture',axis_der_ang,mygreen,1,0,az,el);
  else
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dh_sect_der,'Mx (km)','Hx (km)','dz/dm','Nominal dz/dh',axis_der_ang,mygreen,1,0,az,el);
  end
end

end


%dbquit

clear z_der_gen
clear z_sect_gen
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der
clear mx_sect_der
clear hx_sect_der

if(jump3 ~= 1) 
disp('Compare nominal phase with analytical dz/dh')

disp('Cut section in analytical dz/dh')
[mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'mx',mx_cut);


if(comp_numer)
  disp('Compute numerical dz/dh')
  [mx_sect_gen,hx_sect_gen,z_sect_gen,z_der_gen]=cut_section_der(mx_ang_gen,hx_ang_gen,z_ang_gen,'mx',mx_cut);

  disp('Compare numerical with analytical surf')
  [max_dif,dif_surf]=gen_dif_surf(z_der_gen(3:n_gamma-2),dz_dh_sect_der(3:n_gamma-2),'dz/dh nominal and numerical',flag);
end

if(comp_nomin_phase)
  disp('Cut nominal tangent plane with phase angles')
  [mx_sect_der,hx_sect_der,dz_dh_nomin_phase_sect]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh_nomin_phase,'mx',mx_cut);

  disp('Compare nominal phase with analytical surf')
  [max_dif,dif_surf]=gen_dif_surf(dz_dh_nomin_phase_sect(3:n_gamma-2),dz_dh_sect_der(3:n_gamma-2),'dz/dh analytical and nominal with phase angles',flag);
end

az=90;
el=0;

%[min_z_sect,max_z_sect,min_mx_sect,max_mx_sect,min_hx_sect,max_hx_sect]=max_min_zmx(z_sect_der,mx_sect_der,hx_sect_der,flag);
%axis_der_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_z_sect,1.3*max_z_sect];

if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dh_sect_der),'Mx (km)','Hx (km)','Gamma (deg)','Analytical aperture',axis_der_ang,myblue,0,0,az,el);
else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dh_sect_der,'Mx (km)','Hx (km)','dz/dh','Analytical dz/dh',axis_der_ang,myblue,0,0,az,el);
end

if(comp_nomin)
  [mx_sect_der,hx_sect_der,z_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh_nomin,'mx',mx_cut);
  if(show_ang) 
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(z_sect_der),'Mx (km)','Hx (km)','Gamma (deg)','Nominal aperture',axis_der_ang,mygreen,1,0,az,el);
  else
    [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,z_sect_der,'Mx (km)','Hx (km)','dz/dh','Nominal dz/dh',axis_der_ang,mygreen,1,0,az,el);
  end
end

if(comp_nomin_phase)
  if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(dz_dh_nomin_phase_sect),'Mx (km)','Hx (km)','Gamma (deg)','Reflection aperture',axis_der_ang,myred,1,0,az,el);
  else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,dz_dh_nomin_phase_sect,'Mx (km)','Hx (km)','dz/dh','Nominal phase dz/dh',axis_der_ang,myred,1,0,az,el);
  end
end
  
if(comp_numer)
  if(show_ang) 
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,atand(z_der_gen),'Mx (km)','Hx (km)','Gamma (deg)','Numerical apert',axis_der_ang,mycyan,1,0,az,el);
  else
  [hfig_gen,haxis_gen,hplot_gen]=basic_line(mx_sect_der,hx_sect_der,z_der_gen,'Mx (km)','Hx (km)','dz/dh','Numerical dz/dh',axis_der_ang,mycyan,1,0,az,el);
  end
end

end

if(show_surf)
disp('Show surf')

axis_imp_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_z_ang,1.3*max_z_ang];

%az=30
az=30;
el=40;

[hfig_ang,haxis_ang]=basic_mesh(mx_ang_gen,hx_ang_gen,z_ang_gen,axis_imp_ang,'Mx (km)','Hx (km)','Depth (km)','Iso Gen','copper',1,0,az,el);

[mx_sect_gen,hx_sect_gen,z_sect_gen]=cut_section(mx_ang_gen,hx_ang_gen,z_ang_gen,'mx',mx_cut);

[hfig_sect_gen,haxis_sect_gen,hplot_sect_gen]=basic_line(mx_sect_gen,hx_sect_gen,z_sect_gen,'Mx (km)','Hx (km)','Depth (km)','',axis_imp_ang,myblue,1,1,az,el);

clear z_sect_gen hx_sect_gen mx_sect_gen

[mx_sect_gen,hx_sect_gen,z_sect_gen]=cut_section(mx_ang_gen,hx_ang_gen,z_ang_gen,'hx',hx_cut);

[hfig_sect_gen,haxis_sect_gen,hplot_sect_gen]=basic_line(mx_sect_gen,hx_sect_gen,z_sect_gen,'Mx (km)','Hx (km)','Depth (km)','',axis_imp_ang,myred,1,1,az,el);

end

