% Comparing the tan(gamma) as function of PS vel. ratio and alpha.
% Note that gamma and alpha are related to P-incidence angle,
% S-reflection angle and structural dip.
clear all

clear z_der_gen
clear z_sect_gen 
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der 
clear mx_sect_der
clear hx_sect_der

closereq

addpath /net/koko/homes/sep/daniel/Research/current/Matlab/pswei

g=[0.7:0.2:1.1]

cwv=1;

fprintf('Beginning: backscatter-ps =%d\n',cwv);

mx_cut=0.;
hx_cut=0;

flag=-1;
show_surf=0;
show_ang=0;

bbgreen=[0,1,0];
bbred=[1,0,0];
bbblue=[0,0,1];
bbcyan=[0,1,1];
bbmagenta=[1,0,1];
bbyellow=[1,1,0];
black=[1,1,1];

hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end

for ig=1:length(g)

fprintf('Doing: PS ratio=%d\n',g(ig));

vp_mod=1;
vs_mod=vp_mod/g(ig);

sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);

% Compute surface and its borders
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

fprintf('Cut analytical tangent plane with phase angles at hx=%f \n',hx_cut)
[mx_sect_der(:,ig),hx_sect_der(:,ig),dz_dh_sect_der(:,ig)]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'mx',mx_cut);

dz_dh_all(:,:,ig)=dz_dh;
dz_dm_all(:,:,ig)=dz_dm;

end

%fprintf('Cut analytical tangent plane with phase angles at hx=%f \n',hx_cut)
%[mx_sect_der,hx_sect_der,dz_dm_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dm,'hx',hx_cut);
%fprintf('Cut analytical tangent plane with phase angles at hx=%f \n',hx_cut)
%[mx_sect_der,hx_sect_der,dz_dh_sect_der]=cut_section(mx_ang_gen,hx_ang_gen,dz_dh,'mx',mx_cut);

%if(show_ang)
%  fprintf('Im showing angle')
%  [min_z_sect,max_z_sect,min_mx_sect,max_mx_sect,min_hx_sect,max_hx_sect]=max_min_zmx(atand(dz_dm_sect_der),mx_sect_der,hx_sect_der,flag);
%else
%  [min_z_sect,max_z_sect,min_mx_sect,max_mx_sect,min_hx_sect,max_hx_sect]=max_min_zmx(dz_dm_sect_der,mx_sect_der,hx_sect_der,flag);
%end

%axis_der_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_z_sect,1.3*max_z_sect];

figure
hplot=plot(hx_sect_der(:,1),atand(dz_dh_sect_der(:,1)))
set (hplot,'LineWidth',2);
set (hplot,'Color',bbred);
hold on
hplot=plot(hx_sect_der(:,2),atand(dz_dh_sect_der(:,2)))
set (hplot,'LineWidth',2);
set (hplot,'Color',bbgreen);
hplot=plot(hx_sect_der(:,3),atand(dz_dh_sect_der(:,3)))
set (hplot,'LineWidth',2);
set (hplot,'Color',bbblue);

%hplot=plot(hx_sect_der(:,2),atand(dz_dh_sect_der_all(:,4)))
%set (hplot,'LineWidth',2);
%set (hplot,'Color',bbcyan);
%hplot=plot(hx_sect_der(:,2),atand(dz_dh_sect_der_all(:,5)))
%set (hplot,'LineWidth',2);
%set (hplot,'Color',bbmagenta);
%hplot=plot(hx_sect_der(:,2),atand(dz_dh_sect_der_all(:,6)))
%set (hplot,'LineWidth',2);
%set (hplot,'Color',bbyellow);
%hplot=plot(hx_sect_der(:,2),atand(dz_dh_sect_der_all(:,7)))
%set (hplot,'LineWidth',2);
%set (hplot,'Color',black);

xlabel('Hx (km)');
ylabel('g(o)');
title('Numerical Aper. for different PS ratios');

print -depsc2 ./Fig/ang_cwv_psratio_alpha_surf.ps

%tgt=dz_dh_sect_der;

