% SEP-120.
clear all

clear z_der_gen
clear z_sect_gen 
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der 
clear mx_sect_der
clear hx_sect_der

closereq

cwv=1;

fprintf('Beginning: backscatter-ps =%d\n',cwv);

g=2.0

sg=(g-1)./(g+1)

mx_cut=0.;
hx_cut=0.5;

flag=-1;
show_surf=0;
show_ang=0;

bbgreen=[0,1,0];
bbred=[1,0,0];
bbblue=[0,0,1];
bbcyan=[0,1,1];
bbmagenta=[1,0,1];
bbyellow=[1,1,0];

hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end

fprintf('Doing: PS ratio=%d\n',g);

vp_mod=1;
vs_mod=vp_mod/g;

sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);

% Compute surface and its borders
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

% Compute derivatives numerically
disp('Compute numerical dz/dm')
  [mxa_sect_gen,hxa_sect_gen,z_sect_gen,dz_dm_der_num]=cut_section_der(mx_ang_gen,hx_ang_gen,z_ang_gen,'hx',hx_cut);
disp('Compute numerical dz/dh')
  [mx_sect_gen,hx_sect_gen,z_sect_gen,dz_dh_der_num]=cut_section_der(mx_ang_gen,hx_ang_gen,z_ang_gen,'mx',mx_cut);
  
figure
subplot(1,2,1)
h1=mesh(mx_ang_gen,hx_ang_gen,dz_dh);
view(60,25)

[min_dzdh,max_dzdh,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(dz_dh,mx_ang_gen,hx_ang_gen,flag);
axis_imp_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_dzdh,max_dzdh];
axis(axis_imp_ang);

zlabel('dz/dh');
xlabel('Midpoint');
ylabel('Offset');

hold on

hplot=plot3(mx_sect_gen,hx_sect_gen,dz_dh_der_num);
set (hplot,'LineWidth',4);

subplot(1,2,2)
h2=mesh(mx_ang_gen,hx_ang_gen,dz_dm);
view(60,25)
[min_dzdm,max_dzdm,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(dz_dm,mx_ang_gen,hx_ang_gen,flag);
axis_imp_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_dzdh,max_dzdh];
axis(axis_imp_ang);

zlabel('dz/dm');xlabel('Midpoint');
ylabel('Offset');

hold on

hplot2=plot3(mxa_sect_gen,hxa_sect_gen,dz_dm_der_num);
set (hplot2,'LineWidth',4);

