% SEP-120.
clear all

clear z_der_gen
clear z_sect_gen 
clear hx_sect_gen
clear mx_sect_gen
clear dz_dm_nomin_phase_sect dz_dh_nomin_phase_sect
clear dz_dm_sect_der dz_dh_sect_der

clear z_sect_der 
clear mx_sect_der
clear hx_sect_der

closereq

cwv=1;

fprintf('Beginning: backscatter-ps =%d\n',cwv);

%g=[0.9 1.001 1.3]
g=2.0

sg=(g-1)./(g+1)

mx_cut=0.;
hx_cut=0.5;

flag=-1;
show_surf=0;
show_ang=0;

bbgreen=[0,1,0];
bbred=[1,0,0];
bbblue=[0,0,1];
bbcyan=[0,1,1];
bbmagenta=[1,0,1];
bbyellow=[1,1,0];

hx_data=.5;
%hx_data=.0
mx_data=0.;
t_data=2.;

n_gamma=159;
gamma_0=-79;
d_gamma=1;

n_alpha=159;
alpha_0=-79;
d_alpha=1;

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end

fprintf('Doing: PS ratio=%d\n',g);

vp_mod=1;
vs_mod=vp_mod/g;

sp_par_gen(1)=1/(1*vp_mod);
ss_par_gen(1)=1/(1*vs_mod);

% Compute surface and its borders
[z_ang_gen,mx_ang_gen,hx_ang_gen]=gen_surf_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen,mx_ang_gen,hx_ang_gen,flag);

% Compute tangent plane analytically
[dz_dh,dz_dm]=gen_tan_plane_ang_cwv(@s_cwv,sp_par_gen,ss_par_gen,t_data,mx_data,hx_data,gamma,alpha,cwv,flag);

% Compute kinematic equation

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alp=alpha_0+(i_alpha-1)*d_alpha;
    gam=gamma_0+(i_gamma-1)*d_gamma;
    num=tand(gam)+sg*tand(alp);
    den=1-sg*tand(alp)*tand(gam);
    if den==0
    dz_dh_ke(i_gamma,i_alpha)=NaN;
    else
    dz_dh_ke(i_gamma,i_alpha)=num/den;
    end
  end
end
  
figure

h2=mesh(alpha(1,30:130),gamma(30:130,1),dz_dh_ke(30:130,30:130));
set(h2,'facecolor',[.3 .3 .3]);
set(h2,'edgecolor','none');

hold on

h1=mesh(alpha(1,30:130),gamma(30:130,1),dz_dh(30:130,30:130));
set(h1,'facecolor',[.8 .8 .8]);
min_x=-70;
max_x=70;
min_y=-70;
max_y=70;
min_z=-4;
max_z=4;

axis_imp_ang=[min_x,max_x,min_y,max_y,min_z,max_z];
axis(axis_imp_ang);

zlabel('dz/dh');
xlabel('Alpha');
ylabel('Gamma');

view(-45,20)

