% This is a modification from Biondo's to calculate the parametric
% impulse response for backscatter PS, note that alpha and gamma 
% are releated to P-incidence, S-reflection angles and the structural
% dip. SEP-119
function [z,mx,hx]=gen_surf_ang_cwv(s_func,ss_par,sr_par,t_data_inp,mx_data_inp,hx_data_inp,gamma,alpha,flag)

[n_gamma,n_alpha]=size(gamma);

ts=size(t_data_inp);
if((ts(1) == 1) & (ts(2) == 1))
  for i_alpha=1:n_alpha
    for i_gamma=1:n_gamma
      t_data(i_gamma,i_alpha)=t_data_inp;
      mx_data(i_gamma,i_alpha)=mx_data_inp;
      hx_data(i_gamma,i_alpha)=hx_data_inp;
    end
  end
else
  if((ts(1) ~= n_gamma) & (ts(2) ~= n_alpha))
    disp('gen_surf_ang: error with mismatching sizes')
    dbquit
  end
  t_data=t_data_inp;
  mx_data=mx_data_inp;
  hx_data=hx_data_inp;
end

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    gam=gamma(i_gamma,i_alpha);
    alp=alpha(i_gamma,i_alpha);
    if(abs(cosd(alp)) > abs(sind(gam)))
%    {
      S_s=s_func(ss_par,alp-gam,'group','s');
      S_r=s_func(sr_par,alp+gam,'group','r');
      cos_s=cosd(alp-gam);
      cos_r=cosd(alp+gam);
%      L=.5*t_data*(cos_s+cos_r)/(S_s*cos_s+S_r*cos_r);
%      L=t_data*(cosd(alp)*cosd(gam))/(S_s*cos_s+S_r*cos_r);
%      L=t_data*(cosd(alp)*cosd(gam))/(S_r*cos_s+S_s*cos_r);

%      L=t_data*(cosd(alp)*cosd(gam))/ ...
%         ((S_s+S_r)*cosd(alp)*cosd(gam) + (S_r-S_s)*sind(alp)*sind(gam));

%      invL=((S_s+S_r) + (S_r-S_s)*tand(alp)*tand(gam))/t_data; 

      L=t_data(i_gamma,i_alpha)/((S_s+S_r) + (S_r-S_s)*tand(alp)*tand(gam));
%      L=t_data/((S_s+S_r));

       
      z(i_gamma,i_alpha)=L*(cosd(alp)^2-sind(gam)^2)/(cosd(alp)*cosd(gam));
      mx(i_gamma,i_alpha)=mx_data(i_gamma,i_alpha)-L*sind(alp)/cosd(gam);

%      hx(i_gamma,i_alpha)=L*sind(gam)/cosd(alp)-hx_data;
      hx(i_gamma,i_alpha)=hx_data(i_gamma,i_alpha)-L*sind(gam)/cosd(alp);

%      inv_den=1./(cosd(alp)^2-sind(gam)^2);
%      z(i_gamma,i_alpha)=t_data/(s_func(ss_par,beta_s)/cosd(beta_s) + ... %%% THIS IS NOT MINE
%                                 s_func(sr_par,beta_r)/cosd(beta_r));
%      hx(i_gamma,i_alpha)=hx_data-z(i_gamma,i_alpha)*sind(gam)*cosd(gam)*inv_den;
%      mx(i_gamma,i_alpha)=mx_data-z(i_gamma,i_alpha)*sind(alp)*cosd(alp)*inv_den;
%    }
    else
%    {
      z(i_gamma,i_alpha)=flag;
      mx(i_gamma,i_alpha)=NaN;
      hx(i_gamma,i_alpha)=NaN;
%    }
    end
  end
end

